package com.knauf.ejb.concurrency;
/**
 * Remote interface for Enterprise Bean: Counter
 */
public interface Counter extends javax.ejb.EJBObject
{
	/**
	 * Get accessor for persistent attribute: count
	 */
	public java.lang.Integer getCount() throws java.rmi.RemoteException;
	/**
	 * Set accessor for persistent attribute: count
	 */
	public void setCount(java.lang.Integer newCount)
		throws java.rmi.RemoteException;
	
	/**Geschftsmethode. Fhrt ein Increment durch.
	 * AccessIntent sollte auf "wsPessimisticUpdate-WeakestLockAtLoad" gesetzt werden.
	 * Dazu den Wert von "count" lesen. Dann einige Zeit warten und abschlieend hochsetzen. 
	 * @param _strKennung Eine Kennung, die von auen mitgegeben wird. Dadurch knnen wir
	 * die Methoden unterscheiden. 
	 */
	public void incrementPessimisticUpdateWeakestLockAtLoad(String _strKennung)
		throws java.rmi.RemoteException;
	/**Geschftsmethode. Fhrt ein Increment durch.
	 * AccessIntent sollte auf "wsPessimisticUpdateExclusive" gesetzt werden.
	 * Dazu den Wert von "count" lesen. Dann einige Zeit warten und abschlieend hochsetzen. 
	 * @param _strKennung Eine Kennung, die von auen mitgegeben wird. Dadurch knnen wir
	 * die Methoden unterscheiden. 
	 */
	public void incrementPessimisticUpdateExclusive(String _strKennung)
		throws java.rmi.RemoteException;
	/**Geschftsmethode. Fhrt ein Increment durch.
	 * AccessIntent sollte auf "wsOptimisticUpdate" gesetzt werden.
	 * Dazu den Wert von "count" lesen. Dann einige Zeit warten und abschlieend hochsetzen. 
	 * @param _strKennung Eine Kennung, die von auen mitgegeben wird. Dadurch knnen wir
	 * die Methoden unterscheiden. 
	 */
	public void incrementOptimisticUpdate(String _strKennung)
		throws java.rmi.RemoteException;
}
